﻿using System;
using UnityEngine;

namespace MU3
{
	// Token: 0x02000735 RID: 1845
	[Serializable]
	public class MotionEffectDefine
	{
		// Token: 0x170006FF RID: 1791
		// (get) Token: 0x06002F96 RID: 12182 RVA: 0x000FE2D8 File Offset: 0x000FE2D8
		// (set) Token: 0x06002F97 RID: 12183 RVA: 0x000FE2E0 File Offset: 0x000FE2E0
		public int nameHash { get; private set; }

		// Token: 0x06002F98 RID: 12184 RVA: 0x000FE2EC File Offset: 0x000FE2EC
		public void copyFrom(MotionEffectDefine src)
		{
			this.name = src.name;
			this.prefab = src.prefab;
			this.transform = src.transform;
			this.positionOffset = src.positionOffset;
			this.rotationOffset = src.rotationOffset;
			this.isFollow = src.isFollow;
			this.isSetPosition = src.isSetPosition;
			this.isSetRotation = src.isSetRotation;
			this.isSingleton = src.isSingleton;
			this.isSingletonName = src.isSingletonName;
			this.minimumLife = src.minimumLife;
			this.scaleTransform = src.scaleTransform;
			this.scaleThreashold = src.scaleThreashold;
			this.isDestoryByScale = src.isDestoryByScale;
			this.nameHash = src.nameHash;
		}

		// Token: 0x17000700 RID: 1792
		// (get) Token: 0x06002F99 RID: 12185 RVA: 0x000FE3B0 File Offset: 0x000FE3B0
		public Vector3 positionToFollow
		{
			get
			{
				if (this.transform == null)
				{
					return this.positionOffset;
				}
				return this.transform.TransformPoint(this.positionOffset);
			}
		}

		// Token: 0x17000701 RID: 1793
		// (get) Token: 0x06002F9A RID: 12186 RVA: 0x000FE3DC File Offset: 0x000FE3DC
		public Quaternion rotationToFollow
		{
			get
			{
				if (this.transform == null)
				{
					return this._quaternionOffset;
				}
				return this.transform.rotation * this._quaternionOffset;
			}
		}

		// Token: 0x06002F9B RID: 12187 RVA: 0x000FE40C File Offset: 0x000FE40C
		public void initialize()
		{
			this._quaternionOffset = Quaternion.Euler(this.rotationOffset);
			this.nameHash = this.name.GetHashCode();
		}

		// Token: 0x04005522 RID: 21794
		[SerializeField]
		[Tooltip("名前")]
		public string name;

		// Token: 0x04005523 RID: 21795
		[Tooltip("プレハブ")]
		[SerializeField]
		public GameObject prefab;

		// Token: 0x04005524 RID: 21796
		[Tooltip("発生・追従位置")]
		[SerializeField]
		public Transform transform;

		// Token: 0x04005525 RID: 21797
		[Tooltip("位置オフセット")]
		[SerializeField]
		public Vector3 positionOffset;

		// Token: 0x04005526 RID: 21798
		[Tooltip("回転オフセット")]
		[SerializeField]
		public Vector3 rotationOffset;

		// Token: 0x04005527 RID: 21799
		[Tooltip("発生位置に追従するか")]
		[SerializeField]
		public bool isFollow;

		// Token: 0x04005528 RID: 21800
		[Tooltip("位置をセットするか")]
		[SerializeField]
		public bool isSetPosition;

		// Token: 0x04005529 RID: 21801
		[Tooltip("回転をセットするか")]
		[SerializeField]
		public bool isSetRotation;

		// Token: 0x0400552A RID: 21802
		[Tooltip("再生中の同じエフェクトがあった場合それをDestroyするか")]
		[SerializeField]
		public bool isSingleton;

		// Token: 0x0400552B RID: 21803
		[Tooltip("再生中の同じ名前のエフェクトがあった場合それをDestroyするか")]
		[SerializeField]
		public bool isSingletonName;

		// Token: 0x0400552C RID: 21804
		[Tooltip("再生が終了した場合のDestoryチェックを開始するまでの時間")]
		[SerializeField]
		public float minimumLife;

		// Token: 0x0400552D RID: 21805
		[Tooltip("スケールを参照するtransform")]
		[SerializeField]
		public Transform scaleTransform;

		// Token: 0x0400552E RID: 21806
		[Tooltip("スケールを参照してDestoryする場合の閾値")]
		[SerializeField]
		public float scaleThreashold;

		// Token: 0x0400552F RID: 21807
		[Tooltip("スケールが閾値を超えたらDestoryするか")]
		[SerializeField]
		public bool isDestoryByScale;

		// Token: 0x04005531 RID: 21809
		private Quaternion _quaternionOffset;
	}
}
